#pragma once

#include <cstdlib>
#include <iostream>
#include <iomanip>

using namespace std;

//struktura obsahujici klic a korespondujici data
struct KeyValuePair
{
	string Key;
	int Value;
};

//upraven seznam pro vyuziti v hesovaci tabulce
class List
{
public:

	List();
	~List();
	void Clear();

	//vlozeni klice a hodnoty
	void Insert(string key, int value);

	//smazani zaznamu s danym klicem
	void Delete(string key);

	//vyhledani hodnoty s danym klicem, vraci hodnotu pro dany klic
	int SearchValue(string keyToSearch);

	bool IsEmpty();

	int Count();

	void Reset();

	bool IsEnd();

	void  MoveNext();

	KeyValuePair Current();

private:

	struct ListItem
	{
		KeyValuePair Value;
		ListItem* Prev;
		ListItem* Next;
	};

	ListItem* mHead;
	ListItem* mCurrent;
};