#include "HashTable.h"

void HashTable::Insert(string key, int value)
{
	data[HashFunction(key)].Insert(key, value);
}

//nepli ideln heovac funkce 
//piazuje etzci hodnotu odpovdajc poad prvnho psmena v abeced
//retezcum kter nezacinaj pismenem priradi hodnotu 26
int HashTable::HashFunction(string key)
{
	char first = key[0];
	if (first >= 'A'&&first <= 'Z')
		return first - 65;
	if (first >= 'a'&&first <= 'z')
		return first - 97;
	return 26;
}

int HashTable::getValue(string key)
{
	return data[HashFunction(key)].SearchValue(key);
} 

//funkce getvalue implementovan jako index
int HashTable::operator[](string key)
{
	return data[HashFunction(key)].SearchValue(key);
}

void HashTable::Delete(string key)
{
	data[HashFunction(key)].Delete(key);
}